datablock ProjectileData(keyCardProjectile)
{
   directDamage = 0;

   muzzleVelocity = 200;
   velInheritFactor = 1;

   armingDelay = 0;
   lifetime = 1000;
   fadeDelay = 100;
   bounceElasticity = 0;
   bounceFriction = 0;
   isBallistic = false;
   gravityMod = 0;

   hasLight = false;
   lightRadius = 1.0;
   lightColor = "0 0 0";

   uiName = "";
};

datablock ItemData(keyCardItem)
{
	shapeFile = "Add-Ons/Item_Keycard/keycard.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Keycard White";
	iconName = "Add-Ons/Item_Keycard/Icon_Keycard";
	doColorShift = true;
	colorShiftColor = "1.0 1.0 1.0 1.0";

	image = keyCardImage;
	canDrop = true;
};

datablock ShapeBaseImageData(keyCardImage)
{
	shapeFile = "Add-Ons/Item_Keycard/keycard.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	correctMuzzleVector = false;
	className = "WeaponImage";

	item = keyCardItem;
	ammo = " ";
	projectile = keyCardProjectile;
	projectileType = Projectile;

	melee = true;
	doRetraction = false;
	armReady = true;
	showBricks = false;

	doColorShift = true;
	colorShiftColor = keyCardItem.colorShiftColor;

	raycastWeaponRange = 100;
	raycastWeaponTargets = $TypeMasks::FxBrickObjectType |
		$TypeMasks::PlayerObjectType |
		$TypeMasks::VehicleObjectType;
	raycastWeaponPierceTargets = "";
	raycastFromMuzzle = 0;
	
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]					= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;

	stateName[4]					= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]			= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

function keyCardImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function keyCardImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}